SystemOrganization addCategory: #SoftwareDesign!
SystemOrganization addCategory: #'SoftwareDesign-Algorithm'!
SystemOrganization addCategory: #'SoftwareDesign-Model'!

PolygonMorph subclass: #SDNavEdge
	instanceVariableNames: 'startNode endNode weights type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavEdge class methodsFor: 'instance creation' stamp: 'GNS 11/18/2012 12:21'!
createFrom: aSource to: aDestination withWeight: aWeight

	| edge |
	
	edge := SDNavEdge new.
	edge from: aSource.
	aSource edges add: edge.
	edge to: aDestination.
	edge weights: aWeight.		
	
	^ edge ! !

!SDNavEdge class methodsFor: 'instance creation' stamp: 'bg 12/11/2012 11:01'!
createFrom: aSource to: aDestination withWeight: aWeight andType: aType

	| edge |
	
	edge := SDNavEdge new.
	edge from: aSource.
	aSource edges add: edge.
	edge to: aDestination.
	edge weights: aWeight.	
	edge type: aType.	
	
	^ edge ! !

!SDNavEdge class methodsFor: 'instance creation' stamp: 'bg 12/7/2012 10:07'!
linePrototype
	"Answer an instance of the receiver that will serve as a prototypical arrow"

	| aa |
	aa := self new. 
	aa vertices: (Array with: 0@0 with: 1@1) 
		color: Color black 
		borderWidth: 2 
		borderColor: Color black.
	"aa setProperty: #noNewVertices toValue: true."
	"Revert to expected behavior. Remove vestigial code."
	"aa makeForwardArrow.	"	"is already open"
	aa computeBounds.
	^ aa ! !

!SDNavEdge class methodsFor: 'instance creation' stamp: 'bg 12/7/2012 10:08'!
newWithStartNode: aStartNode andEndNode: anEndNode withWeight: aWeight

	| anEdge |
	
	"Hack..."
	anEdge := self linePrototype.
	anEdge startNode.
	anEdge
		startNode: aStartNode;
		endNode: anEndNode;
		weights: aWeight.
	
	^ anEdge ! !

!SDNavEdge class methodsFor: 'instance creation' stamp: 'bg 12/11/2012 11:10'!
newWithStartNode: aStartNode andEndNode: anEndNode withWeight: aWeight andType: aType

	| anEdge |
	
	"Hack..."
	anEdge := self linePrototype.
	anEdge startNode.
	anEdge
		startNode: aStartNode;
		endNode: anEndNode;
		weights: aWeight;
		type: aType.
	
	^ anEdge ! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/12/2012 20:16'!
applyInitialEdgeAppearance
	
	| verticesPoints |
	
	verticesPoints := self calculateEdgePoints.
	
	self
		color: Color black;
		borderColor: Color black;
		borderWidth: 3.
	
	(self type = 'sidewalk') 
		ifTrue: [self borderWidth: 2.
			self color: Color red.
			self borderColor: Color red].
		
	(self type = 'main_street') 
		ifTrue: [self borderWidth: 5.
			self color: Color black.
			self borderColor: Color black]. 
		
	
	self
		verticesAt: 1 put: (verticesPoints at: 1);
		verticesAt: 2 put: (verticesPoints at: 2);
		lock;
		changed.! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:32'!
applyInitialLabelAppearance

	self label
		contents: self weights asString;
		fontName: self defaultFontName size: self defaultFontSize;
		center: self center + 10;
		lock;
		changed.
	! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:25'!
calculateEdgePoints

	| startPoint endPoint xDifference yDifference|
	
	startPoint := self startNode position.
	endPoint := self endNode position.
	
	xDifference := startPoint x - endPoint x.
	yDifference := startPoint y - endPoint y.
	(xDifference abs < yDifference abs ) 
		ifTrue:
			[(yDifference < 0) 
			ifTrue: 
				[startPoint := startNode bottomCenter.
				endPoint := endNode topCenter.]
			ifFalse:
				[startPoint := startNode topCenter.
				endPoint := endNode bottomCenter.]] 
		ifFalse: 
			[(xDifference < 0) 
			ifTrue: 
				[startPoint := startNode rightCenter.
				endPoint := endNode leftCenter.]
			ifFalse:
				[startPoint := startNode leftCenter.
				endPoint := endNode rightCenter.]].
		
		^ Array with: startPoint with: endPoint
		! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 11/20/2012 17:59'!
defaultFontName

	^ Preferences standardDefaultTextFont familyName! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 11/20/2012 18:00'!
defaultFontSize

	^ 10! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:26'!
drawEdge
	
	self applyInitialEdgeAppearance.! !

!SDNavEdge methodsFor: 'drawing' stamp: 'bg 12/11/2012 15:01'!
drawLabel

	| label |
	
	label := StringMorph contents: self weights asString.
	self
		addMorph: label;
		applyInitialLabelAppearance.
	! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:23'!
drawYourselfOn: aCanvas

	aCanvas addMorph: self.
	self	
		drawEdge;
		drawLabel.! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 12/6/2012 13:45'!
label
	
	^ self submorphs isEmpty ifFalse: [self submorphs first.].! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:31'!
resetYourselfOn: aCanvas
	
	self
		applyInitialEdgeAppearance;
		applyInitialLabelAppearance.! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'bg 12/11/2012 10:59'!
type
	"Answer the value of type"

	^ type! !

!SDNavEdge methodsFor: 'accessing' stamp: 'bg 12/11/2012 10:59'!
type: anObject
	"Set the value of type"

	type := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'bg 12/11/2012 14:59'!
weights
	"Answer the copy of the weights"
	^ weights! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:52'!
weights: anObject
	"Set the value of weights"

	weights := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 12/12/2012 22:57'!
weightsFor: aTransportType
	"Answer the copy of the weights sidewalk main_street"

	self type ifNil:[
		(aTransportType isCar) ifTrue: [^ weights * 2].
		(aTransportType isFeet) ifTrue: [^ weights * 50]
		].
	
	self type = 'sidewalk' ifTrue:[
		(aTransportType isCar) ifTrue: [^ weights * 10000].
		(aTransportType isFeet) ifTrue: [^ weights * 50]
		].
	
	self type = 'main_street' ifTrue:[
		(aTransportType isCar) ifTrue: [^ weights].
		(aTransportType isFeet) ifTrue: [^ weights * 50]
		].
	^ weights! !

Morph subclass: #SDNavAlgorithm
	instanceVariableNames: 'graph startNode endNode stepMethod ended transportType resetEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavAlgorithm class methodsFor: 'instance creation' stamp: 'GNS 11/29/2012 01:15'!
on: aGraph from: theStartNode to: theEndNode

	| algorithm |

	algorithm := self new.
	algorithm
		graph: aGraph;
		startNode: theStartNode;
		endNode: theEndNode.
		
	^ algorithm.! !

!SDNavAlgorithm class methodsFor: 'instance creation' stamp: 'GNS 12/12/2012 20:18'!
on: aGraph from: theStartNode to: theEndNode withTransportType: aTransportype

	| algorithm |

	algorithm := self new.
	algorithm
		graph: aGraph;
		startNode: theStartNode;
		endNode: theEndNode;
		transportType: aTransportype.
		
	^ algorithm.! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:23'!
doingNothing

	"Really doing nothing."! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'bg 12/11/2012 11:14'!
edgeType
	"Answer the value of edgeType"

	^ edgeType! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'bg 12/11/2012 11:14'!
edgeType: anObject
	"Set the value of edgeType"

	edgeType := anObject! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/28/2012 00:16'!
ended
	"Answer the value of ended"

	^ ended! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/28/2012 00:16'!
ended: anObject
	"Set the value of ended"

	ended := anObject! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 12/13/2012 00:06'!
finishAlgorithm
	
	self
		stepMethod: [self doingNothing.];
		ended: true;
		stopStepping.
	
	"mainWindow := self owner.
	mainWindow algorithmFinished.  replaced by informOwner"! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:20'!
firstStep
	
	self subclassResponsibility.! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 12/13/2012 00:05'!
informOwner
	
	| mainWindow |
	
	mainWindow := self owner.
	mainWindow algorithmFinished.! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/29/2012 23:19'!
initialize
	
	super initialize.
	
	self
		initializeAppearance;
		initializeAlgorithm.
	"stepMethod: self firstStep."! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/28/2012 00:18'!
initializeAlgorithm
	
	self
		stepMethod: self firstStep;
		ended: false.! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/29/2012 23:20'!
initializeAppearance
	
	self color: Color transparent.
	
	! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/30/2012 02:13'!
isFinished
	"Answer the value of ended"

	^ ended! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/30/2012 03:12'!
isRunning
	"Answer the value of ended"

	^ ended not! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:23'!
nextStep: aMethodBlock
	
	"The short form for stepMethod:."
	self stepMethod: aMethodBlock.! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/30/2012 02:29'!
reset

	self initializeAlgorithm.! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'bg 12/12/2012 23:56'!
resetEdges
	"Answer the value of resetEdges"

	resetEdges ifNil: [resetEdges := true].

	^ resetEdges! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'bg 12/12/2012 23:55'!
resetEdges: anObject
	"Set the value of resetEdges"

	resetEdges := anObject! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 11:32'!
step
	
	self stepMethod value! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 10:48'!
stepMethod
	"Answer the value of stepMethod"

	^ stepMethod! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 00:39'!
stepMethod: aMethodBlock
	"Set the value of stepMethod"

	stepMethod := aMethodBlock! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 12/7/2012 10:34'!
stepTime
	
	^10! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 12/12/2012 20:15'!
transportType

	^ transportType! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 12/12/2012 20:15'!
transportType: aTransportType

	transportType := aTransportType! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'bg 12/11/2012 11:32'!
type: anObject
	"Set the value of type"

	type := anObject! !

SDNavAlgorithm subclass: #SDNavDijkstraAlgorithm
	instanceVariableNames: 'distances visitedNodes unvisitedNodes predecessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

SDNavDijkstraAlgorithm subclass: #SDNavAStarAlgorithm
	instanceVariableNames: 'calculatedDistances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavAStarAlgorithm methodsFor: 'as yet unclassified' stamp: 'bg 12/10/2012 17:46'!
beelineBetween: aNode and: anotherNode

	^ (((aNode gridPosition x * 50) - (anotherNode gridPosition x * 50)) squared + ((aNode gridPosition y * 50) - (anotherNode gridPosition y * 50)) squared) sqrt roundTo: 2.! !

!SDNavAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/10/2012 18:48'!
calculatedDistances
	"Answer the value of calculatedDistances"

	calculatedDistances ifNil: [
		calculatedDistances := Dictionary new.].
	
	^ calculatedDistances! !

!SDNavAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/10/2012 18:47'!
calculatedDistances: anObject
	"Set the value of calculatedDistances"

	calculatedDistances := anObject! !

!SDNavAStarAlgorithm methodsFor: 'as yet unclassified' stamp: 'bg 12/11/2012 14:45'!
shortestCalculatedDistanceOf: aNode
	
	| distance |
	distance := self calculatedDistances at: aNode ifAbsent: [ ^ 10000000].
	^ distance.! !

!SDNavAStarAlgorithm methodsFor: 'as yet unclassified' stamp: 'bg 12/10/2012 19:01'!
showDistances

	self calculatedDistances keysAndValuesDo: [:node :distance |
		node updateLabelWith: distance.].! !

!SDNavAStarAlgorithm methodsFor: 'as yet unclassified' stamp: 'bg 12/10/2012 18:59'!
step1

	"Init"
	self distances at: self startNode put: 0.
	self calculatedDistances at: self startNode put: 0.
	self unvisitedNodes add: self startNode.
	
	self updateCanvas.
	self unhighlightAllNodes.
	"self nextStep: [self step2.]."
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self nextStep: [self lastStep].].! !

!SDNavAStarAlgorithm methodsFor: 'as yet unclassified' stamp: 'bg 12/10/2012 19:00'!
step3

	"Choose closest unvisited node "
	
	"CloUnvNode means closestUnvisitedNode"
	| cloUnvNode |

	cloUnvNode := nil.
	
	self unvisitedNodes do: [ :unvisitedNode |
		cloUnvNode
			ifNil: [cloUnvNode := unvisitedNode.]
			ifNotNil: [
				((self shortestCalculatedDistanceOf: unvisitedNode)
					< (self shortestCalculatedDistanceOf: cloUnvNode)) ifTrue: [cloUnvNode := unvisitedNode.]].	].
	
	self updateCanvas.
	self highlightNode: cloUnvNode.
	(cloUnvNode = self endNode) 
		ifTrue: [self nextStep: [self lastStep].] 
		ifFalse:[self nextStep: [self step4: cloUnvNode.].].! !

!SDNavAStarAlgorithm methodsFor: 'as yet unclassified' stamp: 'bg 12/12/2012 11:23'!
step5: aNode

	"Visualizing what this "
	
	| unvisitedNeighbors |
	
	unvisitedNeighbors := self unvisitedNeighborsOf: aNode.
	unvisitedNeighbors do: [ :unvisitedNeighbor |
		
		| tempDistance |
		tempDistance := self calculateNewDistanceBetween: aNode and: unvisitedNeighbor. 
		
		((self shortestDistanceOf: unvisitedNeighbor) > tempDistance ) ifTrue: [
			self distances at: unvisitedNeighbor put: tempDistance.
			self calculatedDistances at: unvisitedNeighbor put: (tempDistance + (self beelineBetween: unvisitedNeighbor and: self endNode)).
			self predecessors at: unvisitedNeighbor put: aNode.
			self unvisitedNodes add: unvisitedNeighbor.].
	].
	self updateCanvas.
	self showShortestPathTo: aNode.
	"self nextStep: [self step2.]."
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self nextStep: [self lastStep.].].! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'GNS 12/12/2012 20:22'!
calculateNewDistanceBetween: aNode and: anotherNode

	^(self shortestDistanceOf: aNode) + (aNode distanceTo: anotherNode forTransportType: self transportType).
		! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
distances
	"Answer the value of distance"
	
	distances ifNil: [
		distances := Dictionary new.].
	
	^ distances! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/24/2012 01:24'!
execute

	"Step 1 - start"
	self distances at: self startNode put: 0.
	self unvisitedNodes add: self startNode.
	"Step 1 - end"
	
	"Step 2 - start"
	[self unvisitedNodes size > 0] whileTrue: [ | aNode |
	"Step 2 - end"
		
		"Step 3 - start"	
		aNode := self getMininumOfUnVisitedNodes.
		"Step 3 - end"
		
		"Step 4 - start"
		self visitedNodes add: aNode.
		self unvisitedNodes remove: aNode.
		"Step 4 - end"
		
		"Step 5 - start"
		self findMinimalDistances: aNode.
		"Step 5 - start"
		].
	
	"Step lastStep"! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 12/12/2012 20:22'!
findMinimalDistances: aNode

	| unvisitedNeighbors |
	
	unvisitedNeighbors := self unvisitedNeighborsOf: aNode.
	unvisitedNeighbors do: [ :unvisitedNeighbor |
		
		| tempDistance |
		tempDistance := (self shortestDistanceOf: aNode) + (aNode distanceTo: unvisitedNeighbor forTransportType: self transportType).
		
		((self shortestDistanceOf: unvisitedNeighbor) > tempDistance ) ifTrue: [
			self distances at: unvisitedNeighbor put: tempDistance.
			self predecessors at: unvisitedNeighbor put: aNode.
			self unvisitedNodes add: unvisitedNeighbor.].
	].! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'GNS 11/24/2012 02:20'!
firstStep

	^ [self step1]! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
getMininumOfUnVisitedNodes
	
	| minimum |
	
	minimum := nil.
	
	self unvisitedNodes do: [ :unvisitedNode |
		minimum
			ifNil: [minimum := unvisitedNode.]
			ifNotNil: [
				((self shortestDistanceOf: unvisitedNode)
					< (self shortestDistanceOf: minimum)) ifTrue: [minimum := unvisitedNode.]].	].
	^ minimum! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 12/12/2012 11:21'!
greyAllNodes

	self unvisitedNodes do: [:node |
		node color: Color white].
	self visitedNodes do: [:node |
		node color: Color gray].! !

!SDNavDijkstraAlgorithm methodsFor: 'visualization' stamp: 'bg 11/27/2012 11:43'!
highlightNode: aNode

	self unhighlightAllNodes.
	aNode borderWidth: 4! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 12/13/2012 00:06'!
lastStep
	
	"Do nothing until now."
	Transcript
		show: '---------------------', String cr;
		show: 'Distances ', self distances asString, ' ', String cr;
		show: '---------------------', String cr.
		
	self updateCanvas.
	self unhighlightAllNodes.
	self greyAllNodes.
	self showShortestPathTo: self endNode.
	
	self finishAlgorithm.
	self informOwner.! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
predecessors
	"Answer the value of predecessors"

	predecessors ifNil: [
		predecessors := Dictionary new.].
	
	^ predecessors! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'bg 12/11/2012 14:40'!
shortestDistanceOf: aNode
	
	| distance |
	distance := self distances at: aNode ifAbsent: [ ^ 10000000].
	^ distance.
	! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 12/10/2012 17:38'!
showDistances

	self distances keysAndValuesDo: [:node :distance |
		node updateLabelWith: distance.].! !

!SDNavDijkstraAlgorithm methodsFor: 'visualization' stamp: 'bg 12/7/2012 14:07'!
showShortestPath
	
	| actNode preNode |
	endNode ifNotNil:[
		actNode := endNode.
		[actNode = startNode] whileFalse:
		[
			preNode := self predecessors at: actNode ifAbsent: [
				^ self].
			
			preNode edges do:[ :edge |
				edge endNode = actNode ifTrue:[
					edge borderWidth: 5.
					edge comeToFront.
					edge borderColor: Color lightGreen.
					edge changed.
					Transcript show: edge endNode name.
					].
				].
			actNode := preNode.
			actNode color: Color green.
		]. 
	].! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 12/12/2012 23:55'!
showShortestPathTo: aNode
	
	| actNode preNode |
	(self resetEdges) ifTrue: [self graph resetEdges].
	aNode ifNotNil:[
		actNode := aNode.
		[actNode = startNode] whileFalse:
		[
			preNode := self predecessors at: actNode ifAbsent: [
				^ self].
			
			preNode edges do:[ :edge |
				edge endNode = actNode ifTrue:[
					edge borderWidth: 5.
					edge comeToFront.
					edge borderColor: Color lightGreen.
					edge changed.
					Transcript show: edge endNode name.
					].
				].
			actNode := preNode.
			actNode color: Color green.
		]. 
	].! !

!SDNavDijkstraAlgorithm methodsFor: 'visualization' stamp: 'bg 12/7/2012 11:15'!
showUnvisitedNodes

	self unvisitedNodes do: [:node |
		node color: Color red.].! !

!SDNavDijkstraAlgorithm methodsFor: 'visualization' stamp: 'bg 12/7/2012 11:15'!
showVisitedNodes

	self visitedNodes do: [:node |
		node color: Color green.].! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 11/28/2012 11:22'!
step1

	"Init"
	self distances at: self startNode put: 0.
	self unvisitedNodes add: self startNode.
	
	self updateCanvas.
	self unhighlightAllNodes.
	"self nextStep: [self step2.]."
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self nextStep: [self lastStep].].! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 11/28/2012 11:22'!
step2

	"Visualizing what it this if means"
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self nextStep: [self lastStep.].].
		
	self updateCanvas.
		! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 12/10/2012 17:13'!
step3

	"Choose closest unvisited node "
	
	"CloUnvNode means closestUnvisitedNode"
	| cloUnvNode |

	cloUnvNode := nil.
	
	self unvisitedNodes do: [ :unvisitedNode |
		cloUnvNode
			ifNil: [cloUnvNode := unvisitedNode.]
			ifNotNil: [
				((self shortestDistanceOf: unvisitedNode)
					< (self shortestDistanceOf: cloUnvNode)) ifTrue: [cloUnvNode := unvisitedNode.]].	].
	
	self updateCanvas.
	self highlightNode: cloUnvNode.
	(cloUnvNode = self endNode) 
		ifTrue: [self nextStep: [self lastStep].] 
		ifFalse:[self nextStep: [self step4: cloUnvNode.].].
	
		! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 11/27/2012 09:59'!
step4: aNode

	"Visualizing what this "
	Transcript show: 'Step4 - UnvNodes '.self unvisitedNodes asString.
	
	self visitedNodes add: aNode.
	self unvisitedNodes remove: aNode.
	
	self updateCanvas.
	self nextStep: [self step5: aNode.].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'stepping' stamp: 'bg 12/12/2012 11:13'!
step5: aNode

	"Visualizing what this "
	
	| unvisitedNeighbors |
	
	unvisitedNeighbors := self unvisitedNeighborsOf: aNode.
	
	unvisitedNeighbors do: [ :unvisitedNeighbor |
		
		| tempDistance |
		tempDistance := self calculateNewDistanceBetween: aNode and: unvisitedNeighbor. 
		
		((self shortestDistanceOf: unvisitedNeighbor) > tempDistance ) ifTrue: [
			self distances at: unvisitedNeighbor put: (self calculateNewDistanceBetween: aNode and: unvisitedNeighbor).
			self predecessors at: unvisitedNeighbor put: aNode.
			self unvisitedNodes add: unvisitedNeighbor.].
	].
	self updateCanvas.
	self showShortestPathTo: aNode.
	"self nextStep: [self step2.]."
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self nextStep: [self lastStep.].].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'visualization' stamp: 'bg 11/27/2012 11:42'!
unhighlightAllNodes

	self unvisitedNodes do: [:node |
		node borderWidth: 1].
	self visitedNodes do: [:node |
		node borderWidth: 1].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
unvisitedNeighborsOf: aNode

	| unvisitedNeighbors |
	
	unvisitedNeighbors := OrderedCollection new.
	
	aNode edges do: [ :anEdge |
		
		| destinationNode |
		destinationNode := anEdge endNode.
		
		(self visitedNodes includes: destinationNode) ifFalse: [
			unvisitedNeighbors add: destinationNode.].
		].
	
	^ unvisitedNeighbors  ! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
unvisitedNodes
	"Answer the value of unvisitedNodes"

	unvisitedNodes ifNil: [
		unvisitedNodes := Set new.].
	
	^ unvisitedNodes! !

!SDNavDijkstraAlgorithm methodsFor: 'visualization' stamp: 'bg 11/27/2012 10:10'!
updateCanvas

	self showDistances.
	self showVisitedNodes.
	self showUnvisitedNodes.! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
visitedNodes
	"Answer the value of visitedNodes"

	visitedNodes ifNil: [
		visitedNodes := Set new.].
	
	 ^ visitedNodes! !

SDNavAlgorithm subclass: #SDNavDoubleAStarAlgorithm
	instanceVariableNames: 'algorithmFromStart algorithmFromEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavDoubleAStarAlgorithm class methodsFor: 'as yet unclassified' stamp: 'bg 12/12/2012 23:53'!
on: aGraph from: theStartNode to: theEndNode withTransportType: aTransportype

	| algorithm doubleAlgorithm |
	
	doubleAlgorithm := self new.
	
	algorithm := SDNavAStarAlgorithm new.
	algorithm
		graph: aGraph;
		startNode: theStartNode;
		endNode: theEndNode;
		transportType: aTransportype.
	
	doubleAlgorithm algorithmFromStart: algorithm.
	
	algorithm := SDNavAStarAlgorithm new.
	algorithm
		graph: aGraph;
		startNode: theEndNode;
		endNode: theStartNode;
		transportType: aTransportype;
		resetEdges: false.
	
	doubleAlgorithm algorithmFromEnd: algorithm.
	^ doubleAlgorithm.! !

!SDNavDoubleAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/12/2012 23:49'!
algorithmFromEnd
	"Answer the value of algorithmFromEnd"

	^ algorithmFromEnd! !

!SDNavDoubleAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/12/2012 23:49'!
algorithmFromEnd: anObject
	"Set the value of algorithmFromEnd"

	algorithmFromEnd := anObject! !

!SDNavDoubleAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/12/2012 23:49'!
algorithmFromStart
	"Answer the value of algorithmFromStart"

	^ algorithmFromStart! !

!SDNavDoubleAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/12/2012 23:49'!
algorithmFromStart: anObject
	"Set the value of algorithmFromStart"

	algorithmFromStart := anObject! !

!SDNavDoubleAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/12/2012 23:53'!
checkFinish
	
	self algorithmFromStart visitedNodes do: [:node |
		(self algorithmFromEnd visitedNodes includes: node) ifTrue: [self finishAlgorithmWithNode: node]
		]! !

!SDNavDoubleAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/13/2012 00:07'!
finishAlgorithmWithNode: aNode
	
	self algorithmFromStart updateCanvas;
		unhighlightAllNodes;
		greyAllNodes;
		showShortestPathTo: aNode;
		finishAlgorithm.
		
	self algorithmFromEnd updateCanvas;
		unhighlightAllNodes;
		greyAllNodes;
		showShortestPathTo: aNode;
		finishAlgorithm.
		
	self informOwner.! !

!SDNavDoubleAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/13/2012 00:04'!
firstStep

	^ [self algorithmFromStart step1.
	self algorithmFromEnd step1]! !

!SDNavDoubleAStarAlgorithm methodsFor: 'as yet unclassified' stamp: 'bg 12/13/2012 00:10'!
isFinished
	
	^(self algorithmFromStart isFinished) & (self algorithmFromStart isFinished).! !

!SDNavDoubleAStarAlgorithm methodsFor: 'as yet unclassified' stamp: 'bg 12/13/2012 00:11'!
isRunning
	
	^(self algorithmFromStart isRunning) | (self algorithmFromStart isRunning).! !

!SDNavDoubleAStarAlgorithm methodsFor: 'accessing' stamp: 'bg 12/12/2012 23:54'!
step
	
	self algorithmFromStart stepMethod value.
	self algorithmFromEnd stepMethod value.
	self checkFinish.! !

SDNavAlgorithm subclass: #SDNavLittleAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/29/2012 02:10'!
firstStep

	^ [self sayHuhu].! !

!SDNavLittleAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/29/2012 23:16'!
initialize

	super initialize.
	
self color: Color transparent! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/22/2012 02:27'!
sayHello

	Transcript show: 'Hello'.
	
	self nextStepMethod: [self sayHuhu].! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/22/2012 02:28'!
sayHuhu

	Transcript show: 'Huhu'.
	
	self nextStepMethod: [self sayHello].! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/29/2012 02:08'!
step

	Transcript show: 'Huhu'.! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/29/2012 02:12'!
wantsSteps

	^ true.! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/29/2012 22:51'!
wantsStepsIn: aSystemWindow
	
	^ true! !

Morph subclass: #SDNavGraph
	instanceVariableNames: 'nodes myCanvas startNode endNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

SDNavGraph subclass: #SDNavBerlinSBahnGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavBerlinSBahnGraph methodsFor: 'initialization' stamp: 'GNS 11/20/2012 01:16'!
initialize

	super initialize.
	
	self initializeGraphStructure.! !

!SDNavBerlinSBahnGraph methodsFor: 'initialization' stamp: 'GNS 11/20/2012 01:18'!
initializeGraphStructure	
	
	| nodeA nodeB nodeC nodeD nodeE |
	
	nodeA := SDNavNode createWithName: 'NodeA'.
	nodeB := SDNavNode createWithName: 'NodeB'.   
	nodeC := SDNavNode createWithName: 'NodeC'.
	nodeD := SDNavNode createWithName: 'NodeD'.   
	nodeE := SDNavNode createWithName: 'NodeE'.
	
	nodeA addConnectionTo: nodeB withWeight: 1.
	nodeA addConnectionTo: nodeC withWeight: 1.
	nodeC addConnectionTo: nodeD withWeight: 1.
	nodeD addConnectionTo: nodeE withWeight: 1.
	nodeE addConnectionTo: nodeA withWeight: 1.   
	
	self
		addNode: nodeA;
		addNode: nodeB;
		addNode: nodeC;
		addNode: nodeD;
		addNode: nodeE.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:47'!
addNode: aNode

	self nodes add: aNode.! !

!SDNavGraph methodsFor: 'drawing' stamp: 'bg 11/20/2012 19:55'!
deselectAllNodes

	self nodes do: [:aNode | aNode select: false].! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/20/2012 16:49'!
drawEdges

	self nodes do: [ :aNode |
		aNode edges do: [:anEdge |
			anEdge drawYourselfOn: self myCanvas.].
		].
! !

!SDNavGraph methodsFor: 'drawing' stamp: 'bg 11/20/2012 18:32'!
drawNodes

	self nodes do: [ :aNode |
		aNode drawYourselfOn: self myCanvas.].! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/20/2012 00:56'!
drawYourselfOn: aMorph

	
	self myCanvas: aMorph;
		drawNodes;
		drawEdges.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavGraph methodsFor: 'initialization' stamp: 'GNS 12/12/2012 21:20'!
initialize

	super initialize.
	
	self color: Color transparent.
	self addMorph: (Form fromFileNamed: 'potsdam-karte-v2-bw.gif') asMorph.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
myCanvas
	"Answer the value of myCanvas"

	^ myCanvas! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
myCanvas: anObject
	"Set the value of myCanvas"

	myCanvas := anObject! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/18/2012 15:43'!
nodes
	
	nodes ifNil: [
		nodes := OrderedCollection new.].
	
	^ nodes! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
nodes: anObject
	"Set the value of nodes"

	nodes := anObject! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 12/6/2012 11:29'!
resetEdges

	self nodes do: [ :aNode |
		aNode edges do: [:anEdge |
			anEdge resetYourselfOn: self myCanvas.].].
! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/30/2012 02:57'!
resetNodes

	self nodes do: [ :aNode |
		aNode resetYourselfOn: self myCanvas.].! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 12/6/2012 13:59'!
resetYourselfOn

	self
		resetNodes;
		resetEdges.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/27/2012 10:07'!
setSelectedAsEnd

	self nodes do: [:aNode | 
		aNode isSelected 
		ifTrue:[
			aNode borderColor: Color red.
			self endNode: aNode.]
		ifFalse:[
			(self startNode = aNode) 
			ifFalse:[
				aNode borderColor: Color black.
				]]]! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/27/2012 10:11'!
setSelectedAsStart

	self nodes do: [:aNode | 
		aNode isSelected 
		ifTrue:[
			aNode borderColor: Color green.
			self startNode: aNode.]
		ifFalse:[
			(self endNode = aNode) 
			ifFalse:[
				aNode borderColor: Color black.
				]]]! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

SDNavGraph subclass: #SDNavLittleSampleGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavLittleSampleGraph methodsFor: 'initialization' stamp: 'GNS 11/29/2012 01:42'!
initialize

	super initialize.
	
	self initializeGraphStructure.! !

!SDNavLittleSampleGraph methodsFor: 'initialization' stamp: 'bg 11/27/2012 22:22'!
initializeGraphStructure
	
	| nodeA nodeB nodeC |
	
	nodeA := SDNavNode createWithName: 'A' on: 10@6 in: self.
	nodeB := SDNavNode createWithName: 'B' on: 4@2 in: self.   
	nodeC := SDNavNode createWithName: 'C' on: 3@3 in: self.
	
	nodeA addConnectionTo: nodeB withWeight: 2.
	nodeA addConnectionTo: nodeC withWeight: 5.
	nodeB addConnectionTo: nodeC withWeight: 2.
	nodeB addConnectionTo: nodeA withWeight: 2.
	   
	
	self
		addNode: nodeA;
		addNode: nodeB;
		addNode: nodeC.
	
	! !

SDNavGraph subclass: #SDNavMediumSampleGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavMediumSampleGraph methodsFor: 'initialization' stamp: 'bg 12/11/2012 14:43'!
initialize

	super initialize.
	
	self initializeGraphStructure2.! !

!SDNavMediumSampleGraph methodsFor: 'initialization' stamp: 'bg 12/10/2012 17:37'!
initializeGraphStructure
	
	| nodeA nodeB nodeC nodeD nodeE nodeF nodeG nodeH |
	
	nodeA := SDNavNode createWithName: 'A' on: 0.1@0.1 in: self.
	nodeB := SDNavNode createWithName: 'B' on: 2@3 in: self.   
	nodeC := SDNavNode createWithName: 'C' on: 5@2 in: self.
	nodeD := SDNavNode createWithName: 'D' on: 7@2 in: self.
	nodeE := SDNavNode createWithName: 'E' on: 10@5.5 in: self.
	nodeF := SDNavNode createWithName: 'F' on: 5@4 in: self.
	nodeG := SDNavNode createWithName: 'G' on: 0.5@5.5 in: self.
	nodeH := SDNavNode createWithName: 'H' on: 7.9@0.9 in: self.
	
	nodeA addConnectionTo: nodeB withWeight: 7.
	nodeA addConnectionTo: nodeC withWeight: 4.
	nodeA addConnectionTo: nodeH withWeight: 1.
	nodeA addConnectionTo: nodeG withWeight: 4.
	
	nodeB addConnectionTo: nodeG withWeight: 1.
	
	nodeC addConnectionTo: nodeB withWeight: 2.
	nodeC addConnectionTo: nodeD withWeight: 2.
	nodeC addConnectionTo: nodeF withWeight: 4.
	nodeC addConnectionTo: nodeG withWeight: 4.
	
	nodeD addConnectionTo: nodeE withWeight: 2.
	
	nodeE addConnectionTo: nodeC withWeight: 1.
		
	nodeF addConnectionTo: nodeE withWeight: 2.
	
	nodeG addConnectionTo: nodeF withWeight: 1.
	nodeG addConnectionTo: nodeE withWeight: 4.
	
	nodeH addConnectionTo: nodeC withWeight: 2.
	nodeH addConnectionTo: nodeD withWeight: 7.
	nodeH addConnectionTo: nodeE withWeight: 10.
	   
	
	self
		addNode: nodeA;
		addNode: nodeB;
		addNode: nodeC;
		addNode: nodeD;
		addNode: nodeE;
		addNode: nodeF;
		addNode: nodeG;
		addNode: nodeH.
	
	! !

!SDNavMediumSampleGraph methodsFor: 'initialization' stamp: 'bg 12/11/2012 11:12'!
initializeGraphStructure2
	
	| node0 node1 node2 node3 node4 node5 node6 node7 node8 node9 node10 node11 node12 node13 node14 node15 node16 node17 node18 node19 node20 node21 node22 node23 node24 node25 node26 node27 node28 node29 node30 node31 node32 node33 node34 node35 node36 node37 node38 node39 node40 |

node0 := SDNavNode createWithName: '0' on: 0.52@0.26 in: self.
node1 := SDNavNode createWithName: '1' on: 2.06@1.08 in: self.
node2 := SDNavNode createWithName: '2' on: 2.64@1.42 in: self.
node3 := SDNavNode createWithName: '3' on: 3.1@1.76 in: self.
node4 := SDNavNode createWithName: '4' on: 3.46@1.92 in: self.
node5 := SDNavNode createWithName: '5' on: 4.14@2.46 in: self.
node6 := SDNavNode createWithName: '6' on: 4.68@2.36 in: self.
node7 := SDNavNode createWithName: '7' on: 4.46@2.78 in: self.
node8 := SDNavNode createWithName: '8' on: 4.68@2.94 in: self.
node9 := SDNavNode createWithName: '9' on: 6.38@5.22 in: self.
node10 := SDNavNode createWithName: '10' on: 6.76@5.52 in: self.
node11 := SDNavNode createWithName: '11' on: 8@6.6 in: self.
node12 := SDNavNode createWithName: '12' on: 8.18@7.32 in: self.
node13 := SDNavNode createWithName: '13' on: 8.36@7.48 in: self.
node14 := SDNavNode createWithName: '14' on: 9.48@7.28 in: self.
node15 := SDNavNode createWithName: '15' on: 10.36@7.14 in: self.
node16 := SDNavNode createWithName: '16' on: 11.26@6.96 in: self.
node17 := SDNavNode createWithName: '17' on: 11.62@6.5 in: self.
node18 := SDNavNode createWithName: '18' on: 11.4@5.6 in: self.
node19 := SDNavNode createWithName: '19' on: 10.4@5.84 in: self.
node20 := SDNavNode createWithName: '20' on: 9.36@6.16 in: self.
node21 := SDNavNode createWithName: '21' on: 9.7@4.2 in: self.
node22 := SDNavNode createWithName: '22' on: 9.82@3.68 in: self.
node23 := SDNavNode createWithName: '23' on: 10.58@3.94 in: self.
node24 := SDNavNode createWithName: '24' on: 10.02@2.74 in: self.
node25 := SDNavNode createWithName: '25' on: 9.88@0.1 in: self.
node26 := SDNavNode createWithName: '26' on: 11.6@3.88 in: self.
node27 := SDNavNode createWithName: '27' on: 12.34@5.08 in: self.
node28 := SDNavNode createWithName: '28' on: 13.08@6.16 in: self.
node29 := SDNavNode createWithName: '29' on: 12.1@7.54 in: self.
node30 := SDNavNode createWithName: '30' on: 10.5@7.88 in: self.
node31 := SDNavNode createWithName: '31' on: 9.4@7.8 in: self.
node32 := SDNavNode createWithName: '32' on: 9.36@8.56 in: self.
node33 := SDNavNode createWithName: '33' on: 10.94@8.96 in: self.
node34 := SDNavNode createWithName: '34' on: 8.42@8.32 in: self.
node35 := SDNavNode createWithName: '35' on: 7.24@8.18 in: self.
node36 := SDNavNode createWithName: '36' on: 6.54@8.76 in: self.
node37 := SDNavNode createWithName: '37' on: 5.38@9.22 in: self.
node38 := SDNavNode createWithName: '38' on: 0.82@8.96 in: self.
node39 := SDNavNode createWithName: '39' on: 0.34@5.02 in: self.
node40 := SDNavNode createWithName: '40' on: 1.34@6.76 in: self.
node0 addConnectionTo: node1 withWeight: 87.24 andType: 'main_street'.
node1 addConnectionTo: node0 withWeight: 87.24.
node1 addConnectionTo: node2 withWeight: 33.62 andType: 'sidewalk'.
node1 addConnectionTo: node39 withWeight: 214.95.
node2 addConnectionTo: node1 withWeight: 33.62 andType: 'sidewalk'.
node2 addConnectionTo: node3 withWeight: 28.6.
node3 addConnectionTo: node2 withWeight: 28.6.
node3 addConnectionTo: node4 withWeight: 19.7.
node4 addConnectionTo: node3 withWeight: 19.7.
node4 addConnectionTo: node5 withWeight: 43.42.
node5 addConnectionTo: node4 withWeight: 43.42.
node5 addConnectionTo: node6 withWeight: 27.46.
node5 addConnectionTo: node7 withWeight: 22.63.
node6 addConnectionTo: node5 withWeight: 27.46.
node6 addConnectionTo: node22 withWeight: 265.34.
node7 addConnectionTo: node5 withWeight: 22.63.
node7 addConnectionTo: node8 withWeight: 13.6.
node8 addConnectionTo: node7 withWeight: 13.6.
node8 addConnectionTo: node9 withWeight: 142.2.
node9 addConnectionTo: node8 withWeight: 142.2.
node9 addConnectionTo: node10 withWeight: 24.21.
node9 addConnectionTo: node39 withWeight: 302.17.
node10 addConnectionTo: node9 withWeight: 24.21.
node10 addConnectionTo: node11 withWeight: 82.22.
node10 addConnectionTo: node21 withWeight: 161.14.
node11 addConnectionTo: node10 withWeight: 82.22.
node11 addConnectionTo: node12 withWeight: 37.11.
node11 addConnectionTo: node20 withWeight: 71.47.
node12 addConnectionTo: node11 withWeight: 37.11.
node12 addConnectionTo: node13 withWeight: 12.04.
node12 addConnectionTo: node35 withWeight: 63.7.
node13 addConnectionTo: node12 withWeight: 12.04.
node13 addConnectionTo: node14 withWeight: 56.89.
node13 addConnectionTo: node34 withWeight: 42.11.
node14 addConnectionTo: node13 withWeight: 56.89.
node14 addConnectionTo: node15 withWeight: 44.55.
node14 addConnectionTo: node31 withWeight: 26.31.
node15 addConnectionTo: node14 withWeight: 44.55.
node15 addConnectionTo: node16 withWeight: 45.89.
node15 addConnectionTo: node19 withWeight: 65.03.
node15 addConnectionTo: node30 withWeight: 37.66.
node16 addConnectionTo: node15 withWeight: 45.89.
node16 addConnectionTo: node17 withWeight: 29.21.
node17 addConnectionTo: node16 withWeight: 29.21.
node17 addConnectionTo: node18 withWeight: 46.32.
node18 addConnectionTo: node17 withWeight: 46.32.
node18 addConnectionTo: node19 withWeight: 51.42.
node18 addConnectionTo: node27 withWeight: 53.71.
node19 addConnectionTo: node18 withWeight: 51.42.
node19 addConnectionTo: node20 withWeight: 54.41.
node19 addConnectionTo: node23 withWeight: 95.43.
node19 addConnectionTo: node15 withWeight: 65.03.
node20 addConnectionTo: node19 withWeight: 54.41.
node20 addConnectionTo: node11 withWeight: 71.47.
node20 addConnectionTo: node21 withWeight: 99.46.
node21 addConnectionTo: node20 withWeight: 99.46.
node21 addConnectionTo: node10 withWeight: 161.14.
node21 addConnectionTo: node22 withWeight: 26.68.
node21 addConnectionTo: node23 withWeight: 45.88.
node22 addConnectionTo: node21 withWeight: 26.68.
node22 addConnectionTo: node6 withWeight: 265.34.
node22 addConnectionTo: node24 withWeight: 48.05.
node23 addConnectionTo: node19 withWeight: 95.43.
node23 addConnectionTo: node21 withWeight: 45.88.
node23 addConnectionTo: node24 withWeight: 66.21.
node23 addConnectionTo: node26 withWeight: 51.09.
node24 addConnectionTo: node23 withWeight: 66.21.
node24 addConnectionTo: node22 withWeight: 48.05.
node24 addConnectionTo: node25 withWeight: 132.19.
node25 addConnectionTo: node24 withWeight: 132.19.
node26 addConnectionTo: node23 withWeight: 51.09.
node26 addConnectionTo: node27 withWeight: 70.49.
node27 addConnectionTo: node26 withWeight: 70.49.
node27 addConnectionTo: node18 withWeight: 53.71.
node27 addConnectionTo: node28 withWeight: 65.46.
node28 addConnectionTo: node27 withWeight: 65.46.
node28 addConnectionTo: node29 withWeight: 84.63.
node29 addConnectionTo: node28 withWeight: 84.63.
node29 addConnectionTo: node30 withWeight: 81.79.
node30 addConnectionTo: node29 withWeight: 81.79.
node30 addConnectionTo: node15 withWeight: 37.66.
node30 addConnectionTo: node31 withWeight: 55.15.
node30 addConnectionTo: node33 withWeight: 58.31.
node31 addConnectionTo: node30 withWeight: 55.15.
node31 addConnectionTo: node14 withWeight: 26.31.
node31 addConnectionTo: node32 withWeight: 38.05.
node32 addConnectionTo: node31 withWeight: 38.05.
node32 addConnectionTo: node33 withWeight: 81.49.
node32 addConnectionTo: node34 withWeight: 48.51.
node33 addConnectionTo: node32 withWeight: 81.49.
node33 addConnectionTo: node30 withWeight: 58.31.
node34 addConnectionTo: node32 withWeight: 48.51.
node34 addConnectionTo: node13 withWeight: 42.11.
node34 addConnectionTo: node35 withWeight: 59.41.
node35 addConnectionTo: node34 withWeight: 59.41.
node35 addConnectionTo: node12 withWeight: 63.7.
node35 addConnectionTo: node36 withWeight: 45.45.
node36 addConnectionTo: node35 withWeight: 45.45.
node36 addConnectionTo: node37 withWeight: 62.39.
node37 addConnectionTo: node36 withWeight: 62.39.
node37 addConnectionTo: node38 withWeight: 228.37.
node38 addConnectionTo: node37 withWeight: 228.37.
node38 addConnectionTo: node39 withWeight: 198.46.
node39 addConnectionTo: node38 withWeight: 198.46.
node39 addConnectionTo: node1 withWeight: 214.95.
node39 addConnectionTo: node9 withWeight: 302.17.
node39 addConnectionTo: node40 withWeight: 100.34.
"node39 addConnectionTo: node41 withWeight: 92.96."
node40 addConnectionTo: node39 withWeight: 100.34.
self addNode: node0.
self addNode: node1.
self addNode: node2.
self addNode: node3.
self addNode: node4.
self addNode: node5.
self addNode: node6.
self addNode: node7.
self addNode: node8.
self addNode: node9.
self addNode: node10.
self addNode: node11.
self addNode: node12.
self addNode: node13.
self addNode: node14.
self addNode: node15.
self addNode: node16.
self addNode: node17.
self addNode: node18.
self addNode: node19.
self addNode: node20.
self addNode: node21.
self addNode: node22.
self addNode: node23.
self addNode: node24.
self addNode: node25.
self addNode: node26.
self addNode: node27.
self addNode: node28.
self addNode: node29.
self addNode: node30.
self addNode: node31.
self addNode: node32.
self addNode: node33.
self addNode: node34.
self addNode: node35.
self addNode: node36.
self addNode: node37.
self addNode: node38.
self addNode: node39.
self addNode: node40.

	
	! !

!SDNavMediumSampleGraph methodsFor: 'initialization' stamp: 'bg 12/11/2012 14:32'!
initializeGraphStructure3
	
| node0 node1 node2 node3 node4 node5 node6 node7 node8 |

node0 := SDNavNode createWithName: '0' on: 6.8@5.48 in: self.
node1 := SDNavNode createWithName: '1' on: 8@6.56 in: self.
node2 := SDNavNode createWithName: '2' on: 4.62@3 in: self.
node3 := SDNavNode createWithName: '3' on: 8.46@8.42 in: self.
node4 := SDNavNode createWithName: '4' on: 10.92@8.94 in: self.
node5 := SDNavNode createWithName: '5' on: 10.46@7.18 in: self.
node6 := SDNavNode createWithName: '6' on: 10.48@5.82 in: self.
node7 := SDNavNode createWithName: '7' on: 10.56@4.04 in: self.
node8 := SDNavNode createWithName: '8' on: 0.18@0.16 in: self.
node0 addConnectionTo: node1 withWeight: 80.72 andType: 'sidewalk'.
node0 addConnectionTo: node2 withWeight: 165.1.
node0 addConnectionTo: node7 withWeight: 201.32.
node1 addConnectionTo: node0 withWeight: 80.72 andType: 'sidewalk'.
node1 addConnectionTo: node3 withWeight: 95.8.
node1 addConnectionTo: node6 withWeight: 129.4.
node2 addConnectionTo: node0 withWeight: 165.1.
node2 addConnectionTo: node7 withWeight: 301.52.
node2 addConnectionTo: node8 withWeight: 263.53.
node3 addConnectionTo: node1 withWeight: 95.8.
node3 addConnectionTo: node4 withWeight: 125.72.
node4 addConnectionTo: node3 withWeight: 125.72.
node4 addConnectionTo: node5 withWeight: 90.96.
node5 addConnectionTo: node4 withWeight: 90.96.
node5 addConnectionTo: node6 withWeight: 68.01.
node6 addConnectionTo: node5 withWeight: 68.01.
node6 addConnectionTo: node1 withWeight: 129.4.
node6 addConnectionTo: node7 withWeight: 89.09.
node7 addConnectionTo: node6 withWeight: 89.09.
node7 addConnectionTo: node0 withWeight: 201.32.
node7 addConnectionTo: node2 withWeight: 301.52.
node8 addConnectionTo: node2 withWeight: 263.53.
self addNode: node0.
self addNode: node1.
self addNode: node2.
self addNode: node3.
self addNode: node4.
self addNode: node5.
self addNode: node6.
self addNode: node7.
self addNode: node8.


	
	! !

SystemWindow subclass: #SDNavMainWindow
	instanceVariableNames: 'uiElements algorithm algorithmFactoryMethod assessmentFunction selectedTransportType graph currentlySelectedNode selectedStartNode selectedEndNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 01:55'!
addUIElement: anUIElement at: aKeySymbol 

	self uiElements at: aKeySymbol put: anUIElement.! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 00:08'!
algorithm
	"Answer the value of algorithm"

	^ algorithm! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/6/2012 23:45'!
algorithm: anAlgorithm

	algorithm := anAlgorithm.! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/6/2012 10:38'!
algorithmCanPlay
	
	^ (self selectedStartNode isNil and: [self selectedEndNode isNil]) not! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 16:23'!
algorithmFactoryMethod
	"Answer the value of algorithmFactoryMethod"

	^ algorithmFactoryMethod! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 16:23'!
algorithmFactoryMethod: anObject
	"Set the value of algorithmFactoryMethod"

	algorithmFactoryMethod := anObject! !

!SDNavMainWindow methodsFor: 'api' stamp: 'GNS 12/6/2012 23:40'!
algorithmFinished

	self algorithm isRunning ifTrue: [(Exception new messageText: 'This should not happen') signal.].
	
	self algorithm stopStepping.
	self changePauseBtnToResetBtn.! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/12/2012 20:07'!
applyAlgorithmFactory: anAlgorithmFactoryMethod on: aButtonUIElementKey
	
	self
		deselectAllButtonsWhosKeyEndsWith: 'AlgorithmBtn';
		algorithmFactoryMethod: anAlgorithmFactoryMethod;
		toggleButton: (self uiElement: aButtonUIElementKey).


	! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 11/30/2012 02:10'!
changePauseBtnToPlayBtn

	(self uiElement: #PlayPauseBtn)
		label: 'Play';
		actionSelector: #playAlgorithm.! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 11/30/2012 02:25'!
changePauseBtnToReplayBtn

	(self uiElement: #PlayPauseBtn)
		label: 'Replay';
		actionSelector: #replayAlgorithm.! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/6/2012 23:41'!
changePauseBtnToResetBtn

	(self uiElement: #PlayPauseBtn)
		label: 'Reset';
		actionSelector: #resetAlgorithm.! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 11/30/2012 02:08'!
changePlayBtnToPauseBtn

	(self uiElement: #PlayPauseBtn)
		label: 'Pause';
		actionSelector: #pauseAlgorithm.! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/6/2012 10:07'!
createAlgorithm

	^ self algorithm
		ifNil: [self algorithm: self algorithmFactoryMethod value.].! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'bg 12/13/2012 00:17'!
createAlgorithmAStar
	
	^ SDNavAStarAlgorithm
		on: self graph
		from: self selectedStartNode
		to: self selectedEndNode
		withTransportType: self createTransportType.
	! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/12/2012 22:51'!
createAlgorithmDijkstra
	
	^ SDNavDijkstraAlgorithm
		on: self graph
		from: self selectedStartNode
		to: self selectedEndNode
		withTransportType: self createTransportType.
	! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'bg 12/13/2012 00:17'!
createAlgorithmDoubleAStar
	
	^ SDNavDoubleAStarAlgorithm
		on: self graph
		from: self selectedStartNode
		to: self selectedEndNode
		withTransportType: self createTransportType.
	! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/12/2012 22:53'!
createTransportType
	
	| transportType |
	
	transportType := SDNavTransportType new.
	transportType
		transportTypeSymbol: self selectedTransportType.
		
	^ transportType! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 11:35'!
currentlySelectedNode
	"Answer the value of currentlySelectedNode"

	^ currentlySelectedNode! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 11:35'!
currentlySelectedNode: anObject
	"Set the value of currentlySelectedNode"

	currentlySelectedNode := anObject! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/12/2012 20:03'!
defineTransportType: aTransportTypeSymbol by: aButtonUIElementKey

	| transportTypeSelectionButton |
	
	transportTypeSelectionButton := self uiElement: aButtonUIElementKey.
	
	self
		deselectAllButtonsWhosKeyEndsWith: 'TransportTypeBtn';
		selectedTransportType: aTransportTypeSymbol;
		toggleButton: transportTypeSelectionButton.


	! !

!SDNavMainWindow methodsFor: 'event-actions' stamp: 'GNS 12/2/2012 15:30'!
deselect

	self graph nodes do: [:aNode | aNode asNormalNode.].
	self selectedStartNode ifNotNil: [self selectedStartNode asStartNode].
	self selectedEndNode ifNotNil: [self selectedEndNode asEndNode].! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/12/2012 16:02'!
deselectAllButtonsWhosKeyEndsWith: aSuffx

	self uiElements
		keysDo: [:uiElementKey |
			(uiElementKey asString endsWith: aSuffx)
				ifTrue: [self untoggleButton: (self uiElement: uiElementKey)]. ].! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 00:13'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 00:13'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/28/2012 01:15'!
initialize	
	
	super initialize.
	
	self
		initializeModel;
		initializeAppearance.
	  
	
	
	
	
	! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'bg 12/7/2012 09:45'!
initializeAppearance

	self
		setLabel: 'Navigation System';
		minimumExtent: 810@630;
		position: World center;
		initializeCanvasGraph;
		initializePanelSelect;
		initializePanelControl;
		initializePanelInformation.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'bg 12/13/2012 00:22'!
initializeButtonAlgorithms: aControlPanel

	| button |
	
	button := self makeButton: 'Dijkstra' withAction: #selectAlgorithmDijkstra andState: nil onControlPanel: aControlPanel.
	button center: 280 @ (aControlPanel height / 2).
	aControlPanel addMorph: button.
	self addUIElement: button at: #DijkstraAlgorithmBtn.
	
	button := self makeButton: 'A*' withAction: #selectAlgorithmAStar andState: nil onControlPanel: aControlPanel.
	button center: 325 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: button.
	self addUIElement: button at: #AStarAlgorithmBtn.
	
	button := self makeButton: 'Double A*' withAction: #selectAlgorithmDoubleAStar andState: nil onControlPanel: aControlPanel.
	button center: 380 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: button.
	self addUIElement: button at: #DoubleAStarAlgorithmBtn.
	
	"Set the initial Algorithm"
	self selectAlgorithmDijkstra.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/6/2012 23:39'!
initializeButtonPlayPauseReset: aControlPanel

	| playPauseButton |
	
	playPauseButton := self makeButton: 'Play' withAction: #playAlgorithm andState: nil onControlPanel: aControlPanel.
	playPauseButton center: 30 @ (aControlPanel height / 2).
	aControlPanel addMorph: playPauseButton.
	self addUIElement: playPauseButton at: #PlayPauseBtn! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 15:40'!
initializeButtonStartEnd: aControlPanel

	| button |
	
	button := self makeButton: 'Set Start Point' withAction: #setStart andState: nil onControlPanel: aControlPanel.
	button center: 80 @ (aControlPanel height / 2).
	aControlPanel addMorph: button.
	self addUIElement: button at: #SetStartBtn.
	
	button := self makeButton: 'Set End Point' withAction: #setEnd andState: nil onControlPanel: aControlPanel.
	button center: 180 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: button.
	self addUIElement: button at: #SetEndBtn.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 09:47'!
initializeButtonStep: aControlPanel

	| stepButton |
	
	stepButton := self makeButton: 'Step' withAction: #stepAlgorithm andState: nil onControlPanel: aControlPanel.
	stepButton	
		center: 100 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: stepButton.
	self addUIElement: stepButton at: #StepBtn.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/12/2012 23:00'!
initializeButtonTransportType: aControlPanel

	| button |
	
	button := self makeButton: 'By car' withAction: #selectTransportTypeCar andState: nil onControlPanel: aControlPanel.
	button center: 480 @ (aControlPanel height / 2).
	aControlPanel addMorph: button.
	self addUIElement: button at: #CarTransportTypeBtn.
	
	button := self makeButton: 'By bike' withAction: #selectTransportTypeBike andState: nil onControlPanel: aControlPanel.
	button center: 530 @ (aControlPanel height / 2).
	aControlPanel addMorph: button.
	self addUIElement: button at: #BikeTransportTypeBtn.
	
	button := self makeButton: 'By feet' withAction: #selectTransportTypeFeet andState: nil onControlPanel: aControlPanel.
	button center: 600 @ (aControlPanel height / 2).
	aControlPanel addMorph: button.
	self addUIElement: button at: #FeetTransportTypeBtn.
	
	"Set the initial Algorithm"
	self selectTransportTypeCar.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'bg 12/7/2012 09:40'!
initializeCanvasGraph
	
	self
		loadGraph;
		addUIElement: self graph at: #GraphCanvas;
		
		addMorph: self graph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@50 corner: 0@50 negated)).
	
	self graph
		color: Color transparent;
		drawYourselfOn: self graph;
		lock.
		
	"Define all events"
	self graph on: #click send: #value to: [self deselect].
	self graph nodes
		do: [ :aNode |
			aNode on: #click send: #value to: [self selectNode: aNode].].
	
	
		! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/30/2012 00:14'!
initializeModel

	"self model: SDNavMainWindowModel new."
	self model: Model new. ! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/6/2012 23:39'!
initializePanelControl

	| controlPanel |
	
	controlPanel := Morph new.
	self addMorph: controlPanel fullFrame: (LayoutFrame fractions: (0@1 corner: 0@1) offsets: (0@50 negated corner: 150@0)).
	controlPanel color: Color lightGreen.
	
	self
		initializeButtonPlayPauseReset: controlPanel;
		initializeButtonStep: controlPanel.
	 ! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 09:48'!
initializePanelInformation

	| informationPanel |
	
	informationPanel := Morph new.
	self addMorph: informationPanel fullFrame: (LayoutFrame fractions: (0@1 corner: 1@1) offsets: (150@50 negated corner: 0@0)).
	informationPanel color: Color lightGreen.
	
	"self
		initializePlayPauseButton: informationPanel;
		initializeStepButton: informationPanel."
	 ! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/12/2012 20:00'!
initializePanelSelect

	| selectPanel |
	
	selectPanel := Morph new.
	self addMorph: selectPanel fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@50)).
	selectPanel color: Color lightGreen.
	
	self
		initializeButtonStartEnd: selectPanel;
		initializeButtonAlgorithms: selectPanel;
		initializeButtonTransportType: selectPanel.! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/6/2012 23:45'!
loadAlgorithm
	
	self algorithm: self algorithmFactoryMethod value.
	self addMorph: self algorithm.
	self algorithm stopStepping.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 11:19'!
loadGraph
	
	self graph: SDNavMediumSampleGraph new.	
		
		! !

!SDNavMainWindow methodsFor: 'initialization-helper' stamp: 'GNS 11/20/2012 18:11'!
makeButton: aLabel withAction: anActionSymbol andState: aStateSymbol onControlPanel: aControlPanel
	
	| button |
	
	button := SimpleButtonMorph new.
   	button
		target: self;
		label: aLabel;
		actionSelector: anActionSymbol.
		
	^ button! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 11/30/2012 02:10'!
pauseAlgorithm
	
	self algorithm stopStepping.
	self changePauseBtnToPlayBtn.
	
	! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/6/2012 10:38'!
playAlgorithm

	self algorithmCanPlay ifFalse: [^ self.].
	
	"When no algorithm is set, then we will create one"
	self algorithm ifNil: [self loadAlgorithm.].

	"A running algorithm should not be disturbed"
	self algorithm isStepping ifTrue: [^ self.].
	
	self algorithm startStepping.
	self changePlayBtnToPauseBtn.! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/6/2012 23:42'!
resetAlgorithm

	self graph resetYourselfOn.
	self algorithm abandon.
	self
		algorithm: nil;
		changePauseBtnToPlayBtn.
	! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/12/2012 20:12'!
selectAlgorithmAStar

	self applyAlgorithmFactory:  [self createAlgorithmAStar.] on: #AStarAlgorithmBtn.! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/12/2012 20:12'!
selectAlgorithmDijkstra
	
	self applyAlgorithmFactory: [self createAlgorithmDijkstra.] on: #DijkstraAlgorithmBtn.! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'bg 12/13/2012 00:20'!
selectAlgorithmDoubleAStar

	self applyAlgorithmFactory:  [self createAlgorithmDoubleAStar.] on: #DoubleAStarAlgorithmBtn.! !

!SDNavMainWindow methodsFor: 'event-actions' stamp: 'GNS 12/2/2012 15:20'!
selectNode: theSelectedNode

	self graph nodes do: [:aNode | aNode asNormalNode].
	
	self currentlySelectedNode: theSelectedNode.
	
	self currentlySelectedNode asSelectedNode.
	self selectedStartNode ifNotNil: [self selectedStartNode asStartNode].
	self selectedEndNode ifNotNil: [self selectedEndNode asEndNode].! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/12/2012 20:05'!
selectTransportTypeBike
	
	self defineTransportType: #Bike by: #BikeTransportTypeBtn.! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/12/2012 20:05'!
selectTransportTypeCar
	
	self defineTransportType: #Car by: #CarTransportTypeBtn.! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/12/2012 20:04'!
selectTransportTypeFeet
	
	self defineTransportType: #Feet by: #FeetTransportTypeBtn.! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 14:07'!
selectedEndNode
	"Answer the value of selectedEndNode"

	^ selectedEndNode! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 14:07'!
selectedEndNode: anObject
	"Set the value of selectedEndNode"

	selectedEndNode := anObject! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 14:07'!
selectedStartNode
	"Answer the value of selectedStartNode"

	^ selectedStartNode! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 14:07'!
selectedStartNode: anObject
	"Set the value of selectedStartNode"

	selectedStartNode := anObject! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/12/2012 20:02'!
selectedTransportType

	^ selectedTransportType! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/12/2012 22:50'!
selectedTransportType: aTransportType

	selectedTransportType := aTransportType! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/2/2012 15:23'!
setEnd

	self selectedEndNode
		ifNotNil: [self selectedEndNode asNormalNode].
	self selectedEndNode: self currentlySelectedNode.
	self selectedEndNode asEndNode.! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/2/2012 15:24'!
setStart

	self selectedStartNode
		ifNotNil: [self selectedStartNode asNormalNode].
	self selectedStartNode: self currentlySelectedNode.
	self selectedStartNode asStartNode.! !

!SDNavMainWindow methodsFor: 'button-actions' stamp: 'GNS 12/6/2012 10:41'!
stepAlgorithm

	self algorithmCanPlay ifFalse: [^ self.].
	
	"When no algorithm is set, then we will create one"
	self algorithm ifNil: [self loadAlgorithm.].
	
	"Stop algorithm if it's still stepping"	
	self algorithm isStepping
		ifTrue: [
			self algorithm stopStepping.
			self changePauseBtnToPlayBtn.].
	
	self algorithm isFinished
		ifTrue: [^ self.].
	
	self algorithm step.! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/12/2012 16:02'!
toggleButton: aButton

	aButton 
		borderWidth: 4;
		color: (Color r: 0.4 g: 0.8 b: 0.6) lighter lighter.! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 02:02'!
uiElement: aKeySymbol 

	^ self uiElements at: aKeySymbol asSymbol.! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/29/2012 01:58'!
uiElements

	uiElements ifNil: [uiElements := Dictionary new.].
	^ uiElements! !

!SDNavMainWindow methodsFor: 'button-actions-helper' stamp: 'GNS 12/12/2012 16:02'!
untoggleButton: aButton

	aButton 
		borderWidth: 1;
		color: (Color r: 0.4 g: 0.8 b: 0.6).! !

TestCase subclass: #SDNavDijkstraAlgorithmTestCase
	instanceVariableNames: 'startNode endNode graph distances visitedNodes unvisitedNodes predecessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavDijkstraAlgorithmTestCase methodsFor: 'tests' stamp: 'GNS 11/24/2012 02:42'!
testPlainAlgoVsSteppedAlgo

	| plainAlgo steppedAlgo testGraph |
	
	testGraph := SDNavLittleSampleGraph new.

	plainAlgo := SDNavDijkstraAlgorithm new.
	plainAlgo
		on: testGraph from: testGraph nodes first to: nil;
		execute.
	
	steppedAlgo := SDNavDijkstraAlgorithm new.
	steppedAlgo on: testGraph from: testGraph nodes first to: nil.
	1 to: 20 do: [:i | steppedAlgo step].
	
	
	self
		should: [plainAlgo startNode = steppedAlgo startNode];
		should: [plainAlgo endNode = steppedAlgo endNode];
		should: [plainAlgo distances = steppedAlgo distances];
		should: [plainAlgo visitedNodes = steppedAlgo visitedNodes];
		should: [plainAlgo unvisitedNodes = steppedAlgo unvisitedNodes];
		should: [plainAlgo predecessors = steppedAlgo predecessors].! !

!SDNavDijkstraAlgorithmTestCase methodsFor: 'tests' stamp: 'GNS 11/24/2012 03:02'!
testPlainAlgorithm
	
	| plainAlgo testGraph nodeA nodeB nodeC |
	
	testGraph := SDNavLittleSampleGraph new.
	nodeA := testGraph nodes at: 1.
	nodeB := testGraph nodes at: 2.
	nodeC := testGraph nodes at: 3.
	
	plainAlgo := SDNavDijkstraAlgorithm new.
	plainAlgo
		on: testGraph from: nodeA to: nil;
		execute.
	
	self
		should: [plainAlgo distances isDictionary];
		should: [plainAlgo distances size = 3];
		should: [(plainAlgo distances at: nodeA) = 0];
		should: [(plainAlgo distances at: nodeB) = 2];
		should: [(plainAlgo distances at: nodeC) = 4].! !

Object subclass: #SDNavTransportType
	instanceVariableNames: 'transportTypeSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavTransportType class methodsFor: 'as yet unclassified' stamp: 'GNS 12/12/2012 22:37'!
symbolBike

	^ #Bike! !

!SDNavTransportType class methodsFor: 'as yet unclassified' stamp: 'GNS 12/12/2012 22:37'!
symbolCar

	^ #Car! !

!SDNavTransportType class methodsFor: 'as yet unclassified' stamp: 'GNS 12/12/2012 22:38'!
symbolFeet

	^ #Feet! !

!SDNavTransportType methodsFor: 'initialization' stamp: 'GNS 12/12/2012 22:39'!
asBike

	self transportTypeSymbol: self class symbolBike! !

!SDNavTransportType methodsFor: 'initialization' stamp: 'GNS 12/12/2012 22:38'!
asCar

	self transportTypeSymbol: self class symbolCar! !

!SDNavTransportType methodsFor: 'initialization' stamp: 'GNS 12/12/2012 22:39'!
asFeet

	self transportTypeSymbol: self class symbolFeet! !

!SDNavTransportType methodsFor: 'comparing' stamp: 'GNS 12/12/2012 22:38'!
isBike

	
	^ self transportTypeSymbol = self class symbolBike.! !

!SDNavTransportType methodsFor: 'comparing' stamp: 'GNS 12/12/2012 22:59'!
isCar

	
	^ self transportTypeSymbol = self class symbolCar.! !

!SDNavTransportType methodsFor: 'comparing' stamp: 'GNS 12/12/2012 23:00'!
isFeet

	
	^ self transportTypeSymbol = self class symbolFeet.! !

!SDNavTransportType methodsFor: 'accessing' stamp: 'GNS 12/12/2012 22:30'!
transportTypeSymbol
	"Answer the value of transportTypeSymbol"

	^ transportTypeSymbol! !

!SDNavTransportType methodsFor: 'accessing' stamp: 'GNS 12/12/2012 22:30'!
transportTypeSymbol: anObject
	"Set the value of transportTypeSymbol"

	transportTypeSymbol := anObject! !

CircleMorph subclass: #SDNavNode
	instanceVariableNames: 'gridPosition name edges isSelected graph additionalContent label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavNode class methodsFor: 'instance creation' stamp: 'GNS 11/18/2012 15:41'!
createWithName: aName

	| node |
	
	node := SDNavNode new.
	node name: aName.		
	
	^ node ! !

!SDNavNode class methodsFor: 'instance creation' stamp: 'GNS 12/2/2012 15:26'!
createWithName: aName on: aPoint in: aGraph

	| node |
	
	node := SDNavNode new.
	node name: aName.	
	node gridPosition: aPoint.
	
	node graph: aGraph.
	
	
	^ node ! !

!SDNavNode class methodsFor: 'initial properties' stamp: 'GNS 12/7/2012 15:07'!
defaultFontName

	^ Preferences standardDefaultTextFont familyName! !

!SDNavNode class methodsFor: 'initial properties' stamp: 'GNS 12/7/2012 15:09'!
defaultFontSize

	^ 3! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:41'!
addConnectionTo: aNode withWeight: aWeight

	| edge |
	
	edge := SDNavEdge newWithStartNode: self andEndNode: aNode withWeight: aWeight.
	
	self edges add: edge.
	
	^ edge! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 12/11/2012 11:10'!
addConnectionTo: aNode withWeight: aWeight andType: aType

	| edge |
	
	edge := SDNavEdge newWithStartNode: self andEndNode: aNode withWeight: aWeight andType: aType.
	
	self edges add: edge.
	
	^ edge! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/26/2012 17:13'!
additionalContent
	"Answer the value of additionalContent"

	^ additionalContent! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/27/2012 12:21'!
additionalContent: anObject
	"Set the value of additionalContent"

	additionalContent ifNil: 
	[
		additionalContent := StringMorph.
		self addMorph: additionalContent.
		additionalContent
			fontName: self defaultFontName size: self defaultFontSize - 5;
			lock;
			center: self center + (10@10).
	]! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/12/2012 15:14'!
applyInitialLabelAppearance

	self label
		contents: self name asString;
		fontName: self class defaultFontName size: self class defaultFontSize;
		center: self center + 10;
		lock;
		changed.! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 12/11/2012 11:13'!
applyInitialNodeAppearance: aCanvas

	self
		extent: 12@12; 
		center: aCanvas topLeft + (self gridPosition * 50);
		color: Color white;
		changed.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 14:32'!
asEndNode

	self
		borderWidth: 2.5;
		borderColor: Color red.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 14:32'!
asNormalNode

	self
		borderWidth: 1;
		borderColor: Color black.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 14:38'!
asSelectedNode

	self
		borderWidth: 4;
		borderColor: Color black.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 14:31'!
asStartNode

	self
		borderWidth: 2.5;
		borderColor: Color green.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 09:16'!
asString

	^ self name! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 12/11/2012 11:13'!
defaultFontSize

	^ 8! !

!SDNavNode methodsFor: 'api' stamp: 'bg 12/11/2012 11:26'!
distanceTo: aNode

	
	self edges do: [ :edge |
		(edge endNode = aNode) ifTrue: [^ edge weights ]
		].
	^ 10000! !

!SDNavNode methodsFor: 'api' stamp: 'GNS 12/12/2012 20:22'!
distanceTo: aNode forTransportType: aTransportType

	
	self edges do: [ :edge |
		(edge endNode = aNode) ifTrue: [^ edge weightsFor: aTransportType ]
		].
	^ 10000! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/6/2012 14:18'!
drawLabel

	self label: (StringMorph contents: self name).
	self
		addMorph: label;
		applyInitialLabelAppearance.! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:16'!
drawMorphOn: aCanvas

	self applyInitialNodeAppearance: aCanvas.! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 11/26/2012 17:11'!
drawYourselfOn: aCanvas

	aCanvas addMorph: self. 
	
	self 
		drawMorphOn: aCanvas;
		drawLabel.! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:26'!
edges
	"Answer the value of edges"
	
	edges ifNil: [
		edges := OrderedCollection new.].
	
	^ edges! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 16:59'!
edges: anObject
	"Set the value of edges"

	edges := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 23:08'!
graph

	^graph! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 23:08'!
graph: aGraph

	graph := aGraph! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 17:13'!
gridPosition
	"Answer the value of gridposition"

	^ gridPosition! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 17:13'!
gridPosition: anObject
	"Set the value of gridposition"

	gridPosition := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 19:45'!
isSelected

	isSelected ifNil: [
		isSelected := false.].
	
	^isSelected.! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/26/2012 17:12'!
isSelected: anObject
	"Set the value of isSelected"

	isSelected := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 12/2/2012 09:02'!
label

	^ submorphs first.! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 12/6/2012 14:17'!
label: anLabel

	label := anLabel! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:18'!
name

	^ name! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 12/6/2012 14:20'!
name: anObject
	"Set the value of name"

	name := anObject.! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:18'!
resetYourselfOn: aCanvas
	
	self
		applyInitialNodeAppearance: aCanvas;
		applyInitialLabelAppearance.! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:19'!
updateLabel

	label ifNotNil: [label contents: self name asString.].! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/6/2012 14:23'!
updateLabelWith: aValue
	
	self label contents: aValue asString.! !
